c Updated relative spectral response (RSR) functions, Andrew Sayer
c 31 JAN 2012. andrew.sayer@nasa.gov
c Considered M bands only.
c Used these files for RSRs:
c
c m1:  GT_F1_SC_RSR_Release1.0_Best_M1_V2.71_ib_oob.txt
c m2:  GT_F1_SC_RSR_Release1.0_Best_M2_V2.71_ib_oob.txt
c m3:  GT_F1_SC_RSR_Release1.0_Best_M3_V2.71_ib_oob.txt
c m4:  GT_F1_SC_RSR_Release1.0_Best_M4_V2.71_ib_oob.txt
c m5:  GT_F1_SC_RSR_Release1.0_Best_M5_V2.71_ib_oob.txt
c m6:  GT_F1_SC_RSR_Release1.0_Best_M6_V2.71_ib_oob.txt
c m7:  GT_F1_SC_RSR_Release1.0_Best_M7_V2.71_ib_oob.txt
c m8:  GT_F1_CFPA_RSR_Release1.0_Best_M8_v3_ib_oob.txt
c m9:  GT_F1_CFPA_RSR_Release1.0_Best_M9_v3_ib_oob.txt
c m10: GT_F1_CFPA_RSR_Release1.0_Best_M10_v3_ib_oob.txt
c m11: GT_F1_CFPA_RSR_Release1.0_Best_M11_v3_ib_oob.txt
c m12: GT_F1_CFPA_RSR_Release1.0_Best_M12_v3_ib_oob.txt
c
c Resampled to 2.5 nm wavelength intervals.
c M1-M7 are all-detector averages, others are detector
c 1. Detectors are all very similar, especially when
c you aggregate to 2.5 nm resolution.
c
c These have been tested, to an extent, although I do not
c claim definitively that they are 100% correct. For
c typical aerosol cases, simulations of TOA reflectance
c are typically about 1-3% different from values obtained
c with the old placeholder RSRS, although this is, of course,
c dependent on geometry, atmosphere, surface...
c
c Have commented out old values, above the replacements

      subroutine viirs(iwa)
      common /sixs_ffu/ s(1501),wlinf,wlsup
      real sr(16,1501),wli(16),wls(16)
      real wlinf,wlsup,s
      integer iwa,l,i

c
c    VIIRS band M1
c
c      data (sr(1,l),l=1,1501)/ 61*0.,
c     a 0.7,1.0,1.0,1.0,1.0,
c     a 1.0,1.0,1.0,0.3,
c     a1431*0./

c     BAND M1
      data (sr(1,l),l=1,1501)/
     a 58*0.0,0.015,
     a 0.17,0.50,0.71,0.81,0.86,
     a 0.93,1.0,0.94,0.98,0.60,
     a 0.087,0.030,
     a 150*0.0,0.010,
     a 1279*0.0/

c
c    VIIRS band M2
c
c      data (sr(2,l),l=1,1501) / 74*0.,
c     a 0.1,1.0,1.0,1.0,1.0,
c     a 1.0,1.0,1.0,0.1,
c     a1418*0./

c     BAND m2
      data (sr(2,l),l=1,1501)/
     a 73*0.0,0.034,
     a 0.37,0.76,0.77,0.87,1.0,
     a 0.90,0.61,0.21,0.076,0.019,
     a 1417*0.0/

c
c    VIIRS band M3
c
c      data (sr(3,l),l=1,1501)/ 91*0.,
c     a 0.3,1.0,1.0,1.0,1.0,
c     a 1.0,1.0,1.0,0.7,
c     a1401*0./

c     BAND m3
      data (sr(3,l),l=1,1501)/
     a 89*0.0,0.012,
     a 0.14,0.82,0.99,0.96,1.0,
     a 0.89,0.92,0.98,0.72,0.16,
     a 0.038,0.019,0.014,
     a 1398*0.0/

c
c    VIIRS band M4
c
c      data (sr(4,l),l=1,1501)/ 118*0.,
c     a 0.5,1.0,1.0,1.0,1.0,
c     a 1.0,1.0,1.0,0.5,
c     a1374*0./

c     BAND m4
      data (sr(4,l),l=1,1501)/  
     a 112*0.0,0.011,
     a 0.022,0.048,0.17,0.45,0.82,
     a 0.90,0.93,0.99,0.99,1.0,
     a 0.90,0.57,0.15,0.075,0.036,
     a 0.019,0.011,
     a 1371*0.0/

c
c    VIIRS band M5
c
c      data (sr(5,l),l=1,1501)/ 165*0.,
c     a 0.7,1.0,1.0,1.0,1.0,
c     a 1.0,1.0,1.0,0.3,
c     a1327*0./

c     BAND m5
      data (sr(5,l),l=1,1501)/  
     a 160*0.0,0.015,
     a 0.024,0.050,0.12,0.29,0.61,
     a 0.88,0.98,0.98,0.99,1.0,
     a 0.89,0.57,0.25,0.10,0.046,
     a 0.023,0.012,
     a 1323*0.0/
     
c
c    VIIRS band M6
c
c      data (sr(6,l),l=1,1501)/ 195*0.,
c     a 0.1,1.0,1.0,1.0,1.0,
c     a 1.0,0.9,
c     a1299*0./

c     BAND m6
      data (sr(6,l),l=1,1501)/  
     a 192*0.0,0.012,
     a 0.029,0.10,0.43,0.94,1.0,
     a 0.98,0.98,0.82,0.37,0.097,
     a 0.028,0.010,
     a 1296*0.0/

c
c    VIIRS band M7
c
c      data (sr(7,l),l=1,1501)/ 238*0.,
c     a 0.3,1.0,1.0,1.0,1.0,
c     a 1.0,1.0,1.0,1.0,1.0,
c     a 1.0,1.0,1.0,1.0,1.0,
c     a 1.0,0.3,
c     a1246*0./

c     BAND m7
      data (sr(7,l),l=1,1501)/  
     a 232*0.0,0.012,
     a 0.023,0.048,0.11,0.24,0.50,
     a 0.79,0.95,1.0,0.10,0.99,
     a 0.98,0.97,0.96,0.97,0.97,
     a 0.98,0.98,0.93,0.78,0.55,
     a 0.34,0.18,0.099,0.053,0.029,
     a 0.017,0.010,
     a 1241*0.0/

c
c    VIIRS band M8
c
c      data (sr(8,l),l=1,1501)/ 392*0.,
c     a 0.5,1.0,1.0,1.0,1.0,
c     a 1.0,1.0,1.0,0.5,
c     a1100*0./
c

c     BAND m8
      data (sr(8,l),l=1,1501)/  
     a 386*0.0,0.017,
     a 0.035,0.082,0.21,0.54,0.93,
     a 1.0,0.95,0.94,0.97,0.99,
     a 0.98,0.97,0.89,0.63,0.32,
     a 0.14,0.062,0.030,0.016,
     a 1095*0.0/
     
c
c    VIIRS band M9
c
c      data (sr(9,l),l=1,1501)/ 448*0.,
c     a 0.3,1.0,1.0,1.0,1.0,
c     a 1.0,0.7,
c     a1046*0./
c

c     BAND m9
      data (sr(9,l),l=1,1501)/  
     a 445*0.0,0.025,
     a 0.12,0.55,0.97,0.94,0.99,
     a 1.0,0.91,0.36,0.084,0.022,
     a 1045*0.0/

c
c    VIIRS band M10
c
c      data (sr(10,l),l=1,1501)/ 532*0.,
c     a 0.5,1.0,1.0,1.0,1.0,
c     a 1.0,1.0,1.0,1.0,1.0,
c     a 1.0,1.0,1.0,1.0,1.0,
c     a 1.0,1.0,1.0,1.0,1.0,
c     a 1.0,1.0,1.0,1.0,0.5,
c     a944*0./

c     BAND m10
      data (sr(10,l),l=1,1501)/  
     a 517*0.0,0.012,
     a 0.016,0.022,0.031,0.044,0.063,
     a 0.091,0.13,0.19,0.27,0.38,
     a 0.50,0.62,0.72,0.79,0.82,
     a 0.83,0.81,0.79,0.78,0.79,
     a 0.82,0.85,0.88,0.91,0.92,
     a 0.94,0.96,0.98,1.0,0.99,
     a 0.96,0.87,0.73,0.57,0.43,
     a 0.31,0.22,0.15,0.10,0.075,
     a 0.054,0.040,0.030,0.023,0.018,
     a 0.015,0.012,
     a 936*0.0/

c
c    VIIRS band M11
c
c      data (sr(11,l),l=1,1501)/ 790*0.,
c     a 0.5,1.0,1.0,1.0,1.0,
c     a 1.0,1.0,1.0,1.0,1.0,
c     a 1.0,1.0,1.0,1.0,1.0,
c     a 1.0,1.0,1.0,1.0,1.0,
c     a 0.5,
c     a690*0./

c     BAND m11
      data (sr(11,l),l=1,1501)/  
     a 785*0.0,0.012,
     a 0.017,0.025,0.038,0.061,0.099,
     a 0.16,0.28,0.45,0.67,0.87,
     a 0.98,1.0,0.97,0.94,0.93,
     a 0.94,0.96,0.98,0.10,0.99,
     a 0.97,0.91,0.83,0.75,0.64,
     a 0.53,0.42,0.33,0.23,0.15,
     a 0.097,0.058,0.035,0.021,0.013,
     a 680*0.0/

c     BAND m12
      data (sr(12,l),l=1,1501)/
     a 1307*0.0,0.010,
     a 0.011,0.012,0.014,0.015,0.017,
     a 0.019,0.022,0.025,0.028,0.031,
     a 0.035,0.040,0.045,0.050,0.058,
     a 0.066,0.074,0.084,0.095,0.11,
     a 0.12,0.14,0.16,0.18,0.20,
     a 0.23,0.26,0.29,0.33,0.37,
     a 0.42,0.48,0.53,0.58,0.63,
     a 0.67,0.71,0.75,0.78,0.81,
     a 0.83,0.85,0.87,0.88,0.89,
     a 0.90,0.90,0.91,0.92,0.92,
     a 0.93,0.94,0.94,0.95,0.96,
     a 0.97,0.98,0.98,0.99,0.99,
     a 0.99,0.10,0.10,1.0,0.10,
     a 0.10,0.10,0.99,0.99,0.98,
     a 0.98,0.98,0.98,0.97,0.97,
     a 0.96,0.96,0.95,0.94,0.93,
     a 0.92,0.92,0.91,0.91,0.90,
     a 0.90,0.90,0.90,0.90,0.90,
     a 0.90,0.90,0.89,0.89,0.88,
     a 0.87,0.86,0.84,0.82,0.80,
     a 0.78,0.75,0.72,0.69,0.66,
     a 0.62,0.59,0.55,0.51,0.47,
     a 0.43,0.39,0.35,0.32,0.29,
     a 0.26,0.23,0.21,0.19,0.16,
     a 0.15,0.13,0.12,0.11,0.097,
     a 0.088,0.080,0.072,0.066,0.059,
     a 0.054,0.049,0.044,0.040,0.037,
     a 0.033,0.030,0.027,0.025,0.023,
     a 0.021,0.019,0.017,0.016,0.015,
     a 0.014,0.013,0.011,0.011,
     a 44*0.0/

c
c    VIIRS band M12
c
c      data (sr(12,l),l=1,1501)/ 1344*0.,
c     a 0.5,1.0,1.0,1.0,1.0,
c     a 1.0,1.0,1.0,1.0,1.0,
c     a 1.0,1.0,1.0,1.0,1.0,
c     a 1.0,1.0,1.0,1.0,1.0,
c     a 1.0,1.0,1.0,1.0,1.0,
c     a 1.0,1.0,1.0,1.0,1.0,
c     a 1.0,1.0,1.0,1.0,1.0,
c     a 1.0,1.0,1.0,1.0,1.0,
c     a 1.0,1.0,1.0,1.0,1.0,
c     a 1.0,1.0,1.0,1.0,1.0,
c     a 1.0,1.0,1.0,1.0,1.0,
c     a 1.0,1.0,1.0,1.0,1.0,
c     a 1.0,1.0,1.0,1.0,1.0,
c     a 1.0,1.0,1.0,1.0,1.0,
c     a 1.0,1.0,0.5,
c     a84*0./

c
c    VIIRS band I1
c
      data (sr(13,l),l=1,1501)/ 140*0.,
     a 0.5,1.0,1.0,1.0,1.0,
     a 1.0,1.0,1.0,1.0,1.0,
     a 1.0,1.0,1.0,1.0,1.0,
     a 1.0,1.0,1.0,1.0,1.0,
     a 1.0,1.0,1.0,1.0,1.0,
     a 1.0,1.0,1.0,1.0,1.0,
     a 1.0,1.0,0.5,
     a1328*0./
c
c    VIIRS band I2
c
      data (sr(14,l),l=1,1501)/ 238*0.,
     a 0.3,1.0,1.0,1.0,1.0,
     a 1.0,1.0,1.0,1.0,1.0,
     a 1.0,1.0,1.0,1.0,1.0,
     a 1.0,0.3,
     a1246*0./
c
c    VIIRS band I3
c
      data (sr(15,l),l=1,1501)/ 532*0.,
     a 0.5,1.0,1.0,1.0,1.0,
     a 1.0,1.0,1.0,1.0,1.0,
     a 1.0,1.0,1.0,1.0,1.0,
     a 1.0,1.0,1.0,1.0,1.0,
     a 1.0,1.0,1.0,1.0,0.5,
     a944*0./
c
c    VIIRS band I4
c
      data (sr(16,l),l=1,1501)/ 1320*0.,
     a 0.5,1.0,1.0,1.0,1.0,
     a 1.0,1.0,1.0,1.0,1.0,
     a 1.0,1.0,1.0,1.0,1.0,
     a 1.0,1.0,1.0,1.0,1.0,
     a 1.0,1.0,1.0,1.0,1.0,
     a 1.0,1.0,1.0,1.0,1.0,
     a 1.0,1.0,1.0,1.0,1.0,
     a 1.0,1.0,1.0,1.0,1.0,
     a 1.0,1.0,1.0,1.0,1.0,
     a 1.0,1.0,1.0,1.0,1.0,
     a 1.0,1.0,1.0,1.0,1.0,
     a 1.0,1.0,1.0,1.0,1.0,
     a 1.0,1.0,1.0,1.0,1.0,
     a 1.0,1.0,1.0,1.0,1.0,
     a 1.0,1.0,1.0,1.0,1.0,
     a 1.0,1.0,1.0,1.0,1.0,
     a 1.0,1.0,1.0,1.0,1.0,
     a 1.0,1.0,1.0,1.0,1.0,
     a 1.0,1.0,1.0,1.0,1.0,
     a 1.0,1.0,1.0,1.0,1.0,
     a 1.0,1.0,1.0,1.0,1.0,
     a 1.0,1.0,1.0,1.0,1.0,
     a 1.0,1.0,1.0,1.0,1.0,
     a 1.0,1.0,1.0,1.0,1.0,
     a 1.0,1.0,1.0,1.0,1.0,
     a 1.0,1.0,1.0,1.0,1.0,
     a 1.0,1.0,1.0,1.0,1.0,
     a 1.0,1.0,1.0,1.0,1.0,
     a 1.0,1.0,1.0,1.0,1.0,
     a 1.0,1.0,1.0,1.0,1.0,
     a 1.0,1.0,0.5,
     a28*0./

c
c      wli(1)=0.4025
c      wls(1)=0.4225
c      wli(2)=0.4350
c      wls(2)=0.4550
c      wli(3)=0.4775
c      wls(3)=0.4975
c      wli(4)=0.5450
c      wls(4)=0.5650
c      wli(5)=0.6625
c      wls(5)=0.6825
c      wli(6)=0.7375
c      wls(6)=0.7525
c      wli(7)=0.8450
c      wls(7)=0.8850
c      wli(8)=1.2300
c      wls(8)=1.2500
c      wli(9)=1.3700
c      wls(9)=1.3850
c      wli(10)=1.5800
c      wls(10)=1.6400
c      wli(11)=2.2250
c      wls(11)=2.2750
c      wli(12)=3.6100
c      wls(12)=3.7900
c      wli(13)=0.6000

c I bands: Have not updated these. A M Sayer, 31 Jan 2012
      wli(13)=0.6000
      wls(13)=0.6800
      wli(14)=0.8450
      wls(14)=0.8850
      wli(15)=1.5800
      wls(15)=1.6400
      wli(16)=3.5500
      wls(16)=3.9300

c M bands
      wli(1)=0.3900
      wls(1)=0.4400
      wli(2)=0.4200
      wls(2)=0.4700
      wli(3)=0.4600
      wls(3)=0.5200
      wli(4)=0.5200
      wls(4)=0.6200
      wli(5)=0.6300
      wls(5)=0.7100
      wli(6)=0.7200
      wls(6)=0.7700
      wli(7)=0.8100
      wls(7)=0.9200
      wli(8)=1.2100
      wls(8)=1.2700
      wli(9)=1.3500
      wls(9)=1.4000
      wli(10)=1.5250
      wls(10)=1.7000
      wli(11)=2.2200
      wls(11)=2.3250
      wli(12)=3.4500
      wls(12)=3.9500


      do 1 i=1,1501
      s(i)=sr(iwa,i)
    1 continue
      wlinf=wli(iwa)
      wlsup=wls(iwa)
      return
      end
